diff -urN libwnck.orig/config.h.in libwnck.new/config.h.in
--- libwnck.orig/config.h.in	2008-08-06 23:43:14.009985000 +0100
+++ libwnck.new/config.h.in	2008-08-06 23:43:40.045900000 +0100
@@ -32,6 +32,7 @@
 
 /* Define if you have libstartup-notification */
 #undef HAVE_STARTUP_NOTIFICATION
+#undef HAVE_XTSOL
 
 /* Define to 1 if you have the <stdint.h> header file. */
 #undef HAVE_STDINT_H
diff -urN libwnck.orig/configure.in libwnck.new/configure.in
--- libwnck.orig/configure.ac	2008-08-06 23:43:14.618321000 +0100
+++ libwnck.new/configure.ac	2008-08-06 23:43:40.049192000 +0100
@@ -172,6 +172,15 @@ fi
 
 AC_SUBST(GDK_PIXBUF_CSOURCE)
 
+case "$host" in
+    *-*-solaris*)
+        AC_CHECK_HEADERS(X11/extensions/Xtsol.h sys/tsol/label_macro.h libgnometsol/userattr.h,
+          AC_DEFINE(HAVE_XTSOL, , [Building with XTSOL support]))
+        ;;
+    *)
+        ;;
+esac
+
 ##################################################
 # Checks for gtk-doc and docbook-tools
 ##################################################
diff -urN libwnck.orig/libwnck/pager.c libwnck.new/libwnck/pager.c
--- libwnck.orig/libwnck/pager.c	2008-08-06 23:43:13.356087000 +0100
+++ libwnck.new/libwnck/pager.c	2008-08-06 23:43:40.066590000 +0100
@@ -29,6 +29,7 @@
 #include <math.h>
 #include <glib/gi18n-lib.h>
 
+#include <config.h>
 #include "pager.h"
 #include "workspace.h"
 #include "window.h"
@@ -59,6 +60,11 @@
  * layout.
  */
 
+#ifdef HAVE_XTSOL
+#include "trusted-tooltips.h"
+#include "wnck-tsol.h"
+#endif
+
 #define N_SCREEN_CONNECTIONS 11
 
 struct _WnckPagerPrivate
@@ -82,6 +88,9 @@ struct _WnckPagerPrivate
   WnckWindow *drag_window;
 
   GdkPixbuf *bg_cache;
+#ifdef HAVE_XTSOL
+  TrustedTooltips *tooltips;
+#endif /* HAVE_XTSOL */  
 
   int layout_manager_token;
 
@@ -368,8 +377,8 @@ wnck_pager_realize (GtkWidget *widget)
   attributes.visual = gtk_widget_get_visual (widget);
   attributes.event_mask = gtk_widget_get_events (widget) | GDK_EXPOSURE_MASK |
 	  		  GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK |
-			  GDK_LEAVE_NOTIFY_MASK | GDK_POINTER_MOTION_MASK |
-			  GDK_POINTER_MOTION_HINT_MASK;
+			  GDK_ENTER_NOTIFY_MASK | GDK_LEAVE_NOTIFY_MASK |
+			  GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK;
 
   attributes_mask = GDK_WA_X | GDK_WA_Y | GDK_WA_VISUAL;
 
@@ -1463,6 +1472,53 @@ wnck_pager_draw_workspace (WnckPager    
 		       MAX (0, rect->width - 1), MAX (0, rect->height - 1));
       cairo_stroke (cr);
     }
+#ifdef HAVE_XTSOL
+    {
+      #define DEFAULT_COLOR	"white"
+      const char *label = NULL;
+      char *colorname;
+      int error;
+      GdkColor label_color;
+      m_label_t *mlabel = NULL;
+
+      if (_wnck_check_xtsol_extension() && _wnck_use_trusted_extensions())
+	{
+          label = wnck_workspace_get_label (wnck_screen_get_workspace(pager->priv->screen, workspace));
+	  if (label != NULL && (libtsol_str_to_label (label, &mlabel, MAC_LABEL, L_NO_CORRECTION, &error) == 0)) 
+	  {
+		  cairo_t *cr; 
+		  cr = gdk_cairo_create (gtk_widget_get_window(widget));
+
+		  libtsol_label_to_str (mlabel, &colorname, M_COLOR, DEF_NAMES);
+
+		  if (colorname == NULL)
+			  colorname = g_strdup(DEFAULT_COLOR);
+
+		  gdk_color_parse ((const char*)colorname, &label_color);
+
+		  g_free (colorname);
+
+		  cairo_set_source_rgba (cr,
+				  (double) label_color.red / 65535,
+				  (double) label_color.green / 65535,
+				  (double) label_color.blue / 65535,
+				  0.5);
+		  cairo_set_line_width (cr, 1.0);
+		  cairo_rectangle (cr,
+				  rect->x + 0.5, rect->y + 0.5,
+				  rect->width - 1, rect->height - 1);
+		  cairo_fill (cr);
+		  cairo_destroy (cr);
+	  }
+	  else
+	    {
+	      g_warning("Could not validate sensitivity label \"%s\"", label ? label : "no label defined");
+	    }
+	}
+	  
+    }
+#endif /*HAVE_XTSOL*/
+
 }
 
 static gboolean
@@ -2244,6 +2300,13 @@ wnck_pager_new (void)
   WnckPager *pager;
 
   pager = g_object_new (WNCK_TYPE_PAGER, NULL);
+#ifdef HAVE_XTSOL  
+  if (_wnck_use_trusted_extensions () == TRUE) {
+    pager->priv->tooltips = trusted_tooltips_new ();
+    trusted_tooltips_set_pager (pager->priv->tooltips, pager);
+    g_object_ref_sink (G_OBJECT (pager->priv->tooltips));
+  }
+#endif /* HAVE_XTSOL */  
 
   return GTK_WIDGET (pager);
 }
diff -urN libwnck.orig/libwnck/private.h libwnck.new/libwnck/private.h
--- libwnck.orig/libwnck/private.h	2008-08-06 23:43:13.349065000 +0100
+++ libwnck.new/libwnck/private.h	2008-08-06 23:43:40.073263000 +0100
@@ -35,6 +35,9 @@
 #ifdef HAVE_STARTUP_NOTIFICATION
 #include <libsn/sn.h>
 #endif
+#ifdef HAVE_XTSOL
+#include <tsol/label.h>
+#endif
 
 G_BEGIN_DECLS
 
@@ -102,9 +105,23 @@
 
 void _wnck_workspace_update_name (WnckWorkspace *workspace,
                                   const char    *name);
+#ifdef HAVE_XTSOL
+void _wnck_workspace_update_label (WnckWorkspace *workspace,
+                                   const char    *label);
+void _wnck_workspace_update_role (WnckWorkspace *workspace,
+                                  const char    *role);
+blrange_t * _wnck_workspace_get_range (WnckWorkspace *space);
+#endif
 void _wnck_screen_change_workspace_name (WnckScreen *screen,
                                          int         number,
                                          const char *name);
+#ifdef HAVE_XTSOL
+void _wnck_screen_change_workspace_label (WnckScreen *screen,
+                                          int         number,
+                                          const char *label);
+gboolean _wnck_check_xtsol_extension    ();
+gboolean _wnck_use_trusted_extensions	();
+#endif
 
 gboolean _wnck_workspace_set_geometry (WnckWorkspace *space, int w, int h);
 gboolean _wnck_workspace_set_viewport (WnckWorkspace *space, int x, int y);
diff -urN libwnck.orig/libwnck/screen.c libwnck.new/libwnck/screen.c
--- libwnck.orig/libwnck/screen.c	2008-08-06 23:43:13.472108000 +0100
+++ libwnck.new/libwnck/screen.c	2008-08-06 23:43:40.084085000 +0100
@@ -35,11 +35,17 @@
 #include "class-group.h"
 #include "xutils.h"
 #include "private.h"
+#include "wnck-tsol.h"
 #include <gdk/gdk.h>
 #include <gdk/gdkx.h>
 #include <string.h>
 #include <stdlib.h>
 
+#ifdef HAVE_XTSOL
+#include <tsol/label.h>
+#include <sys/tsol/label_macro.h> 
+#endif
+
 /**
  * SECTION:screen
  * @short_description: an object representing a screen.
@@ -124,6 +130,10 @@ struct _WnckScreenPrivate
   guint need_update_active_window : 1;
   guint need_update_workspace_layout : 1;
   guint need_update_workspace_names : 1;
+#ifdef HAVE_XTSOL
+  guint need_update_workspace_labels : 1;
+  guint need_update_workspace_roles : 1;
+#endif
   guint need_update_bg_pixmap : 1;
   guint need_update_showing_desktop : 1;
   guint need_update_wm : 1;
@@ -148,6 +158,8 @@ enum {
   SHOWING_DESKTOP_CHANGED,
   VIEWPORTS_CHANGED,
   WM_CHANGED,
+  ROLES_CHANGED,
+  LABELS_CHANGED,
   LAST_SIGNAL
 };
 
@@ -162,6 +174,10 @@ static void update_active_workspace   (W
 static void update_active_window      (WnckScreen      *screen);
 static void update_workspace_layout   (WnckScreen      *screen);
 static void update_workspace_names    (WnckScreen      *screen);
+#ifdef HAVE_XTSOL
+static void update_workspace_labels   (WnckScreen      *screen);
+static void update_workspace_roles    (WnckScreen      *screen);
+#endif
 static void update_showing_desktop    (WnckScreen      *screen);
 
 static void queue_update            (WnckScreen      *screen);
@@ -193,6 +209,9 @@ static void emit_showing_desktop_changed
 static void emit_viewports_changed        (WnckScreen      *screen);
 static void emit_wm_changed               (WnckScreen *screen);
 
+void wnck_screen_emit_roles_changed       (WnckScreen *screen);
+void wmck_screen_emit_labels_changed      (WnckScreen *screen);
+
 static guint signals[LAST_SIGNAL] = { 0 };
 
 static void
@@ -502,6 +521,27 @@ wnck_screen_class_init (WnckScreenClass 
                   NULL, NULL,
                   g_cclosure_marshal_VOID__VOID,
                   G_TYPE_NONE, 0);
+
+   /**
+    * Solaris specific signals
+    */
+    signals[ROLES_CHANGED] =
+    g_signal_new ("roles_changed",
+                  G_OBJECT_CLASS_TYPE (object_class),
+                  G_SIGNAL_RUN_LAST,
+                  G_STRUCT_OFFSET (WnckScreenClass, roles_changed),
+                  NULL, NULL,
+                  g_cclosure_marshal_VOID__VOID,
+                  G_TYPE_NONE, 0);
+
+    signals[LABELS_CHANGED] =
+    g_signal_new ("labels_changed",
+                  G_OBJECT_CLASS_TYPE (object_class),
+                  G_SIGNAL_RUN_LAST,
+                  G_STRUCT_OFFSET (WnckScreenClass, labels_changed),
+                  NULL, NULL,
+                  g_cclosure_marshal_VOID__VOID,
+                  G_TYPE_NONE, 0);
 }
 
 static void
@@ -606,6 +646,10 @@ wnck_screen_construct (Display    *displ
   screen->priv->need_update_active_window = TRUE;
   screen->priv->need_update_workspace_layout = TRUE;
   screen->priv->need_update_workspace_names = TRUE;
+#ifdef HAVE_XTSOL
+  screen->priv->need_update_workspace_labels = TRUE;
+  screen->priv->need_update_workspace_roles = TRUE;
+#endif
   screen->priv->need_update_bg_pixmap = TRUE;
   screen->priv->need_update_showing_desktop = TRUE;
   screen->priv->need_update_wm = TRUE;
@@ -1050,6 +1094,20 @@ _wnck_screen_process_property_notify (Wn
       screen->priv->need_update_workspace_names = TRUE;
       queue_update (screen);
     }
+#ifdef HAVE_XTSOL
+  else if (xevent->xproperty.atom ==
+           _wnck_atom_get ("_NET_DESKTOP_LABELS"))
+    {
+      screen->priv->need_update_workspace_labels = TRUE;
+      queue_update (screen);
+    }
+  else if (xevent->xproperty.atom ==
+           _wnck_atom_get ("_NET_DESKTOP_ROLES"))
+    {
+      screen->priv->need_update_workspace_roles = TRUE;
+      queue_update (screen);
+    }
+#endif
   else if (xevent->xproperty.atom ==
            _wnck_atom_get ("_XROOTPMAP_ID"))
     {
@@ -2155,6 +2213,85 @@ update_workspace_names (WnckScreen *scre
   g_list_free (copy);
 }
 
+#ifdef  HAVE_XTSOL
+static void
+update_workspace_labels (WnckScreen *screen)
+{
+  char **labels;
+  int i;
+  GList *tmp;
+  GList *copy;
+
+  if (!screen->priv->need_update_workspace_labels)
+    return;
+
+  screen->priv->need_update_workspace_labels = FALSE;
+
+  labels = _wnck_get_utf8_list (screen->priv->xscreen, screen->priv->xroot,
+                                _wnck_atom_get ("_NET_DESKTOP_LABELS"));
+
+  copy = g_list_copy (screen->priv->workspaces);
+
+  i = 0;
+  tmp = copy;
+  while (tmp != NULL)
+    {
+      if (labels && labels[i])
+        {
+          _wnck_workspace_update_label (tmp->data, labels[i]);
+          ++i;
+        }
+      else
+        _wnck_workspace_update_label (tmp->data, NULL);
+
+      tmp = tmp->next;
+    }
+
+  g_strfreev (labels);
+
+  g_list_free (copy);
+}
+
+static void
+update_workspace_roles (WnckScreen *screen)
+{
+  char **roles;
+  int i;
+  GList *tmp;
+  GList *copy;
+
+  if (!screen->priv->need_update_workspace_roles)
+    return;
+
+  screen->priv->need_update_workspace_roles = FALSE;
+
+  roles = _wnck_get_utf8_list (screen->priv->xscreen, screen->priv->xroot,
+                                _wnck_atom_get ("_NET_DESKTOP_ROLES"));
+
+  copy = g_list_copy (screen->priv->workspaces);
+
+  i = 0;
+  tmp = copy;
+  while (tmp != NULL)
+    {
+      if (roles && roles[i])
+        {
+          _wnck_workspace_update_role (tmp->data, roles[i]);
+          ++i;
+        }
+      else
+        _wnck_workspace_update_role (tmp->data, NULL);
+
+      tmp = tmp->next;
+    }
+
+  g_strfreev (roles);
+
+  g_list_free (copy);
+}
+#endif /* HAVE_XTSOL */
+
+
 static void
 update_bg_pixmap (WnckScreen *screen)
 {
@@ -2244,6 +2381,10 @@ do_update_now (WnckScreen *screen)
     {
       screen->priv->need_update_viewport_settings = TRUE;
       screen->priv->need_update_workspace_names = TRUE;
+#ifdef HAVE_XTSOL
+      screen->priv->need_update_workspace_labels = TRUE;
+      screen->priv->need_update_workspace_roles = TRUE;
+#endif
     }
 
   /* First get our big-picture state in order */
@@ -2256,6 +2397,15 @@ do_update_now (WnckScreen *screen)
   update_active_window (screen);
   update_workspace_layout (screen);
   update_workspace_names (screen);
+#ifdef HAVE_XTSOL
+  /* IMPORTANT
+   * Workspace roles MUST be set before labels 
+   * as the valid label range for role workspaces
+   * is different from the user's min and max label
+   */
+  update_workspace_roles (screen);
+  update_workspace_labels (screen);
+#endif
   update_showing_desktop (screen);
   update_wm (screen);
 
@@ -2424,6 +2574,22 @@ emit_wm_changed (WnckScreen *screen)
                  0);
 }
 
+void
+wnck_screen_emit_roles_changed (WnckScreen *screen)
+{
+  g_signal_emit (G_OBJECT (screen),
+                 signals[ROLES_CHANGED],
+                 0);
+}
+
+void
+wnck_screen_emit_labels_changed (WnckScreen *screen)
+{
+  g_signal_emit (G_OBJECT (screen),
+                 signals[LABELS_CHANGED],
+                 0);
+}
+
 /**
  * wnck_screen_get_window_manager_name:
  * @screen: a #WnckScreen.
@@ -2755,3 +2921,86 @@ _wnck_screen_change_workspace_name (Wnck
 
   g_free (names);
 }
+
+#ifdef HAVE_XTSOL
+void
+_wnck_screen_change_workspace_label (WnckScreen *screen,
+                                    int         number,
+                                    const char *label)
+{
+  int n_spaces;
+  char **labels;
+  int i;
+  int error=-2;
+  m_label_t *mlabel = NULL;
+
+  static char		*lower_sl_str = NULL;
+  static char		*upper_clear_str = NULL;
+  static blrange_t	*workspace_range = NULL;
+
+  WnckWorkspace		*tmp_space = NULL;
+  
+  /* First check that we are running in a trusted windowing environment */
+  if (! _wnck_check_xtsol_extension ()) {
+      g_warning("Workspace labelling can not work with out the SUN_TSOL X extension");
+      return;
+  }
+
+  if (!_wnck_use_trusted_extensions())
+      return;
+
+  /* 
+   * Label must be validated.
+   * Convert the label string to a binary MAC_LABEL type.
+   * Then check that it is in the workspace's range which 
+   * depends on what role (if any) the workspace has.
+   */
+  
+  if (libtsol_str_to_label (label, &mlabel, MAC_LABEL, L_NO_CORRECTION, &error) < 0) {
+      g_warning("Could not validate sensitivity label \"%s\"", label);
+      return;
+  }
+
+  tmp_space = wnck_screen_get_workspace (screen, number);
+  /* need to refresh the role cache if an app is calling change label 
+   * after setting directly the _NET_DESKTOP_ROLES as this wouldn't have been 
+   * updated in libwnck yet */
+  screen->priv->need_update_workspace_roles = TRUE;
+  update_workspace_roles (screen); 
+   workspace_range = _wnck_workspace_get_range (tmp_space);
+
+  if (!libtsol_blinrange (mlabel, workspace_range)) {
+      g_warning("Could not change the sensitivity label of workspace %d because \"%s\" "
+                "appears to be outside of the workspace's label range", number, label);
+      libtsol_m_label_free (mlabel);
+      return;
+  }
+
+  n_spaces = wnck_screen_get_workspace_count (screen);
+
+  labels = g_new0 (char*, n_spaces + 1);
+
+  i = 0;
+  while (i < n_spaces) {
+      if (i == number)
+          labels[i] = (char*) label;
+      else {
+          WnckWorkspace *workspace;
+          workspace = wnck_screen_get_workspace (screen, i);
+          if (workspace) {
+              labels[i] = (char*) wnck_workspace_get_label (workspace);
+              if (labels[i] == NULL)
+                  labels[i] = (char*) ""; /* Maybe a g_warning too ? */
+          } else
+              labels[i] = (char*) ""; /* maybe this should be a g_warning too */
+      }
+      i++;
+  }
+
+  _wnck_set_utf8_list (screen->priv->xscreen, screen->priv->xroot,
+                       _wnck_atom_get ("_NET_DESKTOP_LABELS"),
+                       labels);
+  libtsol_m_label_free (mlabel);
+  g_free (labels);
+}
+#endif /* HAVE_XTSOL */
diff -urN libwnck.orig/libwnck/screen.h libwnck.new/libwnck/screen.h
--- libwnck.orig/libwnck/screen.h	2011-02-18 04:01:52.526645403 -0600
+++ libwnck.new/libwnck/screen.h	2011-02-18 04:03:08.974857147 -0600
@@ -109,6 +109,12 @@ struct _WnckScreenClass
   /* Window manager changed */
   void (* window_manager_changed)   (WnckScreen      *screen);
 
+  /* Roles changed */
+  void (* roles_changed)            (WnckScreen      *screen);
+
+  /* Labels changed */
+  void (* labels_changed)           (WnckScreen      *screen);
+
   /* Padding for future expansion */
   void (* pad2) (void);
   void (* pad3) (void);
@@ -270,6 +276,9 @@ void           wnck_screen_calc_workspac
 void           wnck_screen_free_workspace_layout (WnckWorkspaceLayout *layout);
 #endif /* WNCK_DISABLE_DEPRECATED */
 
+void wnck_screen_emit_roles_changed (WnckScreen *screen);
+void wnck_screen_emit_labels_changed (WnckScreen *screen);
+
 
 G_END_DECLS
 
diff -urN libwnck.orig/libwnck/tasklist.c libwnck.new/libwnck/tasklist.c
--- libwnck.orig/libwnck/tasklist.c	2008-08-06 23:43:13.368589000 +0100
+++ libwnck.new/libwnck/tasklist.c	2008-08-06 23:43:40.101354000 +0100
@@ -36,6 +36,10 @@
 #include "workspace.h"
 #include "xutils.h"
 #include "private.h"
+#ifdef HAVE_XTSOL 
+#include "wnck-tsol.h"
+#include "trusted-tooltips.h"
+#endif /* HAVE_XTSOL */
 
 /**
  * SECTION:tasklist
@@ -198,6 +202,10 @@
   GHashTable *class_group_hash;
   GHashTable *win_hash;
 
+#ifdef HAVE_XTSOL
+  TrustedTooltips *tooltips;
+#endif /*HAVE_XTSOL*/
+
   gint max_button_width;
   gint max_button_height;
 
@@ -1970,6 +1978,10 @@
   WnckTasklist *tasklist;
 
   tasklist = g_object_new (WNCK_TYPE_TASKLIST, NULL);
+#ifdef HAVE_XTSOL
+  if (_wnck_use_trusted_extensions () == TRUE)
+    tasklist->priv->tooltips = trusted_tooltips_new ();
+#endif /*HAVE_XTSOL*/
 
   return GTK_WIDGET (tasklist);
 }
@@ -2833,6 +2845,10 @@
 	{
 	  image = gtk_image_new_from_pixbuf (pixbuf);
 	  gtk_widget_show (image);
+#ifdef HAVE_XTSOL
+      if (_wnck_check_xtsol_extension() && _wnck_use_trusted_extensions())
+	image = window_menu_create_label_indicator (win_task->window, image);
+#endif /*HAVE_XTSOL*/	  
 	  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_item),
 					 image);
 	  g_object_unref (pixbuf);
@@ -3225,6 +3241,15 @@
   text = wnck_task_get_text (task, TRUE, TRUE);
   if (text != NULL)
     {
+#ifdef HAVE_XTSOL
+    if (_wnck_use_trusted_extensions () == TRUE)
+        trusted_tooltips_set_tip (task->tasklist->priv->tooltips,
+                                task->button,
+                                 text,
+                                 task->window ? wnck_window_get_label_human_readable (task->window) : "",
+                                 task->window ? wnck_window_get_label_color (task->window) : NULL,
+                                 NULL);
+#endif /* HAVE_XTSOL */
       gtk_label_set_text (GTK_LABEL (task->label), text);
       if (wnck_task_get_needs_attention (task))
         {
@@ -3706,7 +3731,24 @@
   g_free (text);
 
   text = wnck_task_get_text (task, FALSE, FALSE);
+#ifdef HAVE_XTSOL
+  if (_wnck_use_trusted_extensions () == TRUE)
+    {
+      if (task->window)
+        {
+         trusted_tooltips_set_tip (task->tasklist->priv->tooltips,
+                                   task->button,
+                                   text,
+                                   wnck_window_get_label_human_readable (task->window),
+                                   wnck_window_get_label_color (task->window),
+                                   NULL);
+        }
+    else
+      trusted_tooltips_set_tip (task->tasklist->priv->tooltips, task->button, text, "Hum No Label", NULL, NULL);
+  }
+#else
   gtk_widget_set_tooltip_text (task->button, text);
+#endif /*HAVE_XTSOL*/
   g_free (text);
 
   /* Set up signals */
@@ -4032,6 +4074,56 @@
 #endif
 }
 
+#ifdef HAVE_XTSOL
+static void
+draw_trusted_label (GtkWidget* widget, WnckTask *task)
+{
+  GtkStyle *style;
+  int x_offset;
+  ConstraintImage *cimage;
+  GdkRectangle area;
+  GtkAllocation image_allocation;
+  GtkAllocation allocation;
+  GtkAllocation label_allocation;
+  GtkAllocation button_allocation;
+
+  style = gtk_widget_get_style(task->button);
+  /* get the width of the icon and the padding */
+  gtk_widget_get_allocation (task->image, &image_allocation);
+  x_offset = image_allocation.width + (style->xthickness *2);
+
+  gtk_widget_get_allocation (widget, &allocation);
+  area.x = allocation.x + x_offset;
+  area.y = allocation.y + 2;
+  area.width = allocation.width - x_offset;
+  gtk_widget_get_allocation (task->label, &label_allocation);
+  gtk_widget_get_allocation (task->button, &button_allocation);
+  area.height = label_allocation.y - button_allocation.y;
+
+  cimage = get_highlight_stripe ((char*)wnck_window_get_label (task->window),
+                                wnck_window_get_label_color (task->window));
+
+  if (cimage)
+    libgnome_tsol_constraint_image_render (cimage, gtk_widget_get_window(widget),
+                                          NULL, &area,
+                                          FALSE,
+                                          area.x,
+                                          area.y,
+                                          area.width,
+                                          area.height);
+}
+
+
+gboolean
+wnck_task_class_expose (GtkWidget        *widget,
+                       GdkEventExpose   *event,
+                       gpointer          data)
+{
+  draw_trusted_label (widget, (WnckTask*) data);
+  return FALSE;
+}
+#endif /* HAVE_XTSOL */
+
 static WnckTask *
 wnck_task_new_from_window (WnckTasklist *tasklist,
 			   WnckWindow   *window)
@@ -4047,6 +4139,14 @@
 
   wnck_task_create_widgets (task, tasklist->priv->relief);
 
+#ifdef HAVE_XTSOL
+  if (_wnck_check_xtsol_extension() && _wnck_use_trusted_extensions())
+    g_signal_connect_object (task->button, "expose_event",
+                            G_CALLBACK (wnck_task_class_expose),
+                            G_OBJECT (task),
+                            G_CONNECT_AFTER);
+#endif /* HAVE_XTSOL */
+
   remove_startup_sequences_for_window (tasklist, window);
 
   return task;
